<?php



function ConvertFractionToDecimal($fraction)

{

    $result = "";

    if (isset($fraction))

    {

        eval ("\$result = 1.0*$fraction;");

    }

    return $result;

}



function ExifConvertDegMinSecToDD($deg, $min, $sec)

{

    $dec_min = ($min*60.0 + $sec)/60.0;

    $result  = ($deg*60.0 + $dec_min)/60.0;

    return $result;

}



// pad function taken from Exif reader 1.2 by Richard James Kendall, richard@richardjameskendall.com

// takes $data and pads it from the left so strlen($data) == $shouldbe

function pad($data, $shouldbe, $put) {

	if (strlen($data) == $shouldbe) {

		return $data;

	} else {

		$padding = "";

		for ($i = strlen($data);$i < $shouldbe;$i++) {

			$padding .= $put;

		}

		return $padding . $data;

	}

}



// flashvalue function taken from Exif reader 1.2 by Richard James Kendall, richard@richardjameskendall.com

// takes the USHORT of the flash value, splits it up into itc component bits and returns the string it represents

function flashvalue($bin) {

	$retval = "";

	$bin = pad(decbin($bin), 8, "0");

	$flashfired = substr($bin, 7, 1);

	$returnd = substr($bin, 5, 2);

	$flashmode = substr($bin, 3, 2);

	$redeye = substr($bin, 1, 1);

	if ($flashfired == "1") {

		$retval = "Fired";

	} else {

		if ($flashfired == "0") {

			$retval = "Did not fire";

		}

	}

	if ($returnd == "10") {

		$retval .= ", Strobe return light not detected";

	} else {

		if ($returnd == "11") {

			$retval .= ", Strobe return light detected";

		}

	}

	if ($flashmode == "01" || $flashmode == "10") {

		$retval .= ", Compulsory mode";

	} else {

		if ($flashmode == "11") {

			$retval .= ", Auto mode";

		}

	}

	if ($redeye) {

		$retval .= ", Red eye reduction";

	} else {

		$retval .= ", No red eye reduction";

	}

	return $retval;

}



// Yuck!

$exif_data = array();



function exif($filename)

{

    global $exif_data;



    $rawexif = exif_read_data($filename, 0, true);



    // Fill in exif_data in the same format as the default exif reader.

    $exif_data['Model'] = $rawexif['IFD0']['Model'];

    $exif_data['ExposureTime'] = $rawexif['EXIF']['ExposureTime'];

    $exif_data['FNumber'] = ConvertFractionToDecimal($rawexif['EXIF']['FNumber']);

    $exif_data['FocalLength'] = ConvertFractionToDecimal($rawexif['EXIF']['FocalLength']);

    $exif_data['ISOSpeedRating'] = $rawexif['EXIF']['ISOSpeedRatings'];

    $exif_data['ExposureBias'] = $rawexif['EXIF']['ExposureBiasValue'];

    $exif_data['Flash'][0] = $rawexif['EXIF']['Flash'];

    $exif_data['Flash'][1] = flashvalue($rawexif['EXIF']['Flash']);

    $exif_data['DTDigitised'] = $rawexif['EXIF']['DateTimeDigitized'];



    // My own stuff



    if (isset($rawexif[GPS][GPSVersion]))

    {

        $exif_data['GPSVersion'] = $rawexif[GPS][GPSVersion];



        $deg = ConvertFractionToDecimal($rawexif[GPS][GPSLatitude][0]);

        $min = ConvertFractionToDecimal($rawexif[GPS][GPSLatitude][1]);

        $sec = ConvertFractionToDecimal($rawexif[GPS][GPSLatitude][2]);

        $exif_data['GPSLatitude'] = ExifConvertDegMinSecToDD($deg, $min, $sec);

        $exif_data['GPSLatitudeRef'] = $rawexif['GPS']['GPSLatitudeRef'];



        $deg = ConvertFractionToDecimal($rawexif[GPS][GPSLongitude][0]);

        $min = ConvertFractionToDecimal($rawexif[GPS][GPSLongitude][1]);

        $sec = ConvertFractionToDecimal($rawexif[GPS][GPSLongitude][2]);

        $exif_data['GPSLongitude'] = ExifConvertDegMinSecToDD($deg, $min, $sec);

        $exif_data['GPSLongitudeRef'] = $rawexif['GPS']['GPSLongitudeRef'];

    }



    // Now add brand specific stuff...

    if($rawexif['IFD0']['Make'] == "Canon")

    {

        require_once('canon_php_exif.php');

        parseCanon($rawexif);

    }

}



?>

